Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Moog Class Reference

STK moog-like swept filter sampling synthesis class. More...

`#include <Moog.h>`

Inheritance diagram for stk::Moog:

List of all members.

## Public Member Functions
| Moog (void)
| Class constructor.
| ~Moog (void)
| Class destructor.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | setModulationSpeed (StkFloat mSpeed)
| Set the modulation (vibrato) speed in Hz.
void | setModulationDepth (StkFloat mDepth)
| Set the modulation (vibrato) depth.
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK moog-like swept filter sampling synthesis class.

This instrument uses one attack wave, one looped wave, and an ADSR envelope (inherited from the Sampler class) and adds two sweepable formant (FormSwep) filters.

Control Change Numbers:

- Filter Q = 2
- Filter Sweep Rate = 4
- Vibrato Frequency = 11
- Vibrato Gain = 1
- Gain = 128

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::Moog::Moog | ( | void |  | ) |

Class constructor.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

StkFrames & stk::Moog::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Sampler.

    00097 {
    00098   unsigned int nChannels = lastFrame_.channels();
    00099 #if defined(_STK_DEBUG_)
    00100   if ( channel > frames.channels() - nChannels ) {
    00101     oStream_ << "Moog::tick(): channel and StkFrames arguments are incompatible!";
    00102     handleError( StkError::FUNCTION_ARGUMENT );
    00103   }
    00104 #endif
    00105
    00106   StkFloat *samples = &frames[channel];
    00107   unsigned int j, hop = frames.channels() - nChannels;
    00108   if ( nChannels == 1 ) {
    00109     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00110       *samples++ = tick();
    00111   }
    00112   else {
    00113     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00114       *samples++ = tick();
    00115       for ( j=1; j<nChannels; j++ )
    00116         *samples++ = lastFrame_[j];
    00117     }
    00118   }
    00119
    00120   return frames;
    00121 }

The documentation for this class was generated from the following file:

- Moog.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.